use algorithms::crc::{CHECK_DATA, Crc, Crc32, ffi};
use criterion::{Criterion, black_box, criterion_group, criterion_main};

pub fn criterion_benchmark(c: &mut Criterion) {
    c.bench_function("crc32", |b| {
        b.iter(|| Crc32::checksum(black_box(&CHECK_DATA)))
    });
    c.bench_function("ffi::crc32", |b| {
        b.iter(|| ffi::Crc32::checksum(black_box(&CHECK_DATA)))
    });
}

criterion_group!(benches, criterion_benchmark);
criterion_main!(benches);
